# -*- coding: utf-8 -*-
"""
Created on Sun Sep  1 18:40:43 2024

@author: Sebastian
"""

#%% imports
import sys
sys.path.append("./general/")
sys.path.append("./image_processing/")
sys.path.append("./image_analysis/")
sys.path.append("./puzzle_solving/")
import cv2
import numpy as np
from scipy.spatial import distance
import matplotlib.pyplot as plt

from PuzzlePieceExtractor import PuzzlePieceExtractor
from ImageAnalyser import ImageAnalyser
from Side import Side, SideType
from PuzzlePiece import PuzzlePiece, Category

#%% script
# load image
print("load image")
image_path= "../resources/demo_images/all_mixed.jpg"
image = cv2.imread(image_path)

# create puzzle piece extractor
print("create PuzzlePieceExtractor")
extractor = PuzzlePieceExtractor()

# extract puzzle pieces
print("extract pieces")
im_pieces, im_gray_pieces = extractor.generate_pieces(image)

# convetr image to puzzle pieces
print("convert image to piece objects")
pieces = []
image_analyser = ImageAnalyser()


for i in range(len(im_gray_pieces)):
    print(f"piece {i} of {len(im_gray_pieces)}")
    image_analyser.image = im_gray_pieces[i]
    image_analyser.piece_id = i
    pieces.append(image_analyser.analyse())
    

for i in range(len(im_gray_pieces)):
    cv2.imshow("Test", im_gray_pieces[i])
    cv2.waitKey(0)