# -*- coding: utf-8 -*-
"""
Created on Fri May 17 17:50:27 2024

@author: Jessica
"""

from PuzzlePiece import PuzzlePiece
from Side import Side

class MatchingCounterpiece:
    """
    A class used to represent a matching counterpiece to a puzzle piece and one of its sides.
    
    Attributes
    ----------
    __piece : PuzzlePiece
        puzzle piece
    __side : Side
        side
    __distance : int
        distance to the other puzzle piece and side
        
    """
    
    def __init__(self, piece: PuzzlePiece, side: Side, distance):
        self.__piece = piece
        self.__side = side
        self.__distance = distance
        
    def get_piece(self):
        return self.__piece
    
    def set_piece(self, piece):
        self.__piece = piece
    
    def get_side(self):
        return self.__side
    
    def set_side(self, side):
        self.__side = side
        
    def get_distance(self):
        return self.__distance
    
    def set_distance(self, distance):
        self.__distance = distance
    
    piece = property(get_piece, set_piece)
    side = property(get_side, set_side)
    distance = property(get_distance, set_distance)
    
    
    